import _ladifireCssSassComponentsCheckboxScss from "@ladifire-css/sass/components/checkbox.scss";
import _ladifireCssSassIndexScss from "@ladifire-css/sass/index.scss";
import { CheckMarkIcon } from "@ladifire-ui-react/icons";
import { useToggleState } from "@react-stately/toggle";
import { useProviderProps } from "@ladifire-ui-react/provider";
import { useHover } from "@react-aria/interactions";
import { useCheckbox } from "@react-aria/checkbox";
import { FocusRing } from "@react-aria/focus";
import _spectrumIconsUiDashSmall from "@spectrum-icons/ui/DashSmall";
import { classNames, useFocusableRef, useStyleProps } from "@react-spectrum/utils";
import * as _react from "react";
import _babelRuntimeHelpersEsmObjectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _babelRuntimeHelpersEsmExtends from "@babel/runtime/helpers/esm/extends";

function $ad86caa2b7c07dadd21ed122a0b52380$var$Checkbox(props, ref) {
  props = useProviderProps(props);

  let {
    isIndeterminate = false,
    isEmphasized = false,
    isDisabled = false,
    autoFocus,
    children,
    disabledHoverBackground = false
  } = props,
      otherProps = _babelRuntimeHelpersEsmObjectWithoutPropertiesLoose(props, ["isIndeterminate", "isEmphasized", "isDisabled", "autoFocus", "children", "disabledHoverBackground"]);

  let {
    styleProps
  } = useStyleProps(otherProps);
  let {
    hoverProps,
    isHovered
  } = useHover(props);

  let inputRef = _react.useRef(null);

  let domRef = useFocusableRef(ref, inputRef);
  let state = useToggleState(props);
  let {
    inputProps
  } = useCheckbox(props, state, inputRef);
  let markIcon = isIndeterminate ? /*#__PURE__*/_react.createElement(_spectrumIconsUiDashSmall, {
    UNSAFE_className: "spectrum-Checkbox-partialCheckmark"
  }) : /*#__PURE__*/_react.createElement(CheckMarkIcon, {
    size: 18,
    className: classNames(_ladifireCssSassIndexScss, _ladifireCssSassComponentsCheckboxScss.check_mark, _ladifireCssSassIndexScss.display__inline_block, _ladifireCssSassIndexScss.pointer_event__none, _ladifireCssSassIndexScss.fill_current, _ladifireCssSassIndexScss.width__18, _ladifireCssSassIndexScss.height__18, _ladifireCssSassIndexScss.position__absolute, _ladifireCssSassIndexScss.color__white, _ladifireCssSassIndexScss.opacity__0, {
      [_ladifireCssSassIndexScss.opacity__1]: state.isSelected
    })
  });
  return /*#__PURE__*/_react.createElement("label", _babelRuntimeHelpersEsmExtends({}, styleProps, hoverProps, {
    ref: domRef,
    className: classNames(_ladifireCssSassIndexScss, _ladifireCssSassIndexScss.display__inline_flex, _ladifireCssSassIndexScss.box_sizing__border_box, _ladifireCssSassIndexScss.align_item__flex_start, _ladifireCssSassIndexScss.position__relative, _ladifireCssSassIndexScss.vertical_align__top, _ladifireCssSassIndexScss.max_width__100_percent, _ladifireCssSassIndexScss.isolation__isolate, styleProps.className) // className={
    //   classNames(
    //     styles,
    //     'spectrum-Checkbox',
    //     {
    //       'is-checked': state.isSelected,
    //       'is-indeterminate': isIndeterminate,
    //       'spectrum-Checkbox--quiet': !isEmphasized,
    //       'is-invalid': inputProps['aria-invalid'],
    //       'is-disabled': isDisabled,
    //       'is-hovered': isHovered
    //     },
    //     styleProps.className
    //   )
    // }

  }), /*#__PURE__*/_react.createElement(FocusRing, {
    focusRingClass: "focus-ring",
    autoFocus: autoFocus
  }, /*#__PURE__*/_react.createElement("input", _babelRuntimeHelpersEsmExtends({}, inputProps, {
    ref: inputRef,
    className: classNames(_ladifireCssSassIndexScss, _ladifireCssSassIndexScss.margin__0, _ladifireCssSassIndexScss.overflow__visible, _ladifireCssSassIndexScss.box_sizing__border_box, _ladifireCssSassIndexScss.padding_0, _ladifireCssSassIndexScss.position__absolute, _ladifireCssSassIndexScss.top__0, _ladifireCssSassIndexScss.height__100_percent, _ladifireCssSassIndexScss.z_index__1, _ladifireCssSassIndexScss.cursor__pointer, _ladifireCssSassIndexScss.opacity__00001, _ladifireCssSassIndexScss.width__100_percent, {
      [_ladifireCssSassIndexScss.pointer_event__none]: isDisabled
    })
  }))), /*#__PURE__*/_react.createElement("span", {
    className: classNames(_ladifireCssSassIndexScss, _ladifireCssSassIndexScss.position__relative, _ladifireCssSassIndexScss.box_sizing__border_box, _ladifireCssSassIndexScss.flex_grow__0, _ladifireCssSassIndexScss.flex_grow__1, _ladifireCssSassIndexScss.ms_flex_negative__0, _ladifireCssSassIndexScss.ms_flex_positive__0, _ladifireCssSassIndexScss.height__18, _ladifireCssSassIndexScss.width__18, _ladifireCssSassComponentsCheckboxScss.checkbox_box, {
      [_ladifireCssSassComponentsCheckboxScss.checkbox_box__checked]: state.isSelected,
      [_ladifireCssSassIndexScss.opacity__05]: isDisabled
    })
  }, markIcon, !disabledHoverBackground && /*#__PURE__*/_react.createElement("div", {
    className: classNames(_ladifireCssSassIndexScss, _ladifireCssSassIndexScss.position__absolute, _ladifireCssSassIndexScss.top__0, _ladifireCssSassIndexScss.left__0, _ladifireCssSassIndexScss.right__0, _ladifireCssSassIndexScss.bottom__0, _ladifireCssSassIndexScss.opacity__0, _ladifireCssSassIndexScss.transition_timing_function__fade_out, _ladifireCssSassIndexScss.pointer_event__none, _ladifireCssSassIndexScss.transition_duration__short_out, _ladifireCssSassIndexScss.transition_property__opacity, _ladifireCssSassIndexScss.cursor__pointer, _ladifireCssSassIndexScss.border_radius__50_percent, _ladifireCssSassIndexScss.background_color__hover_overlay, _ladifireCssSassIndexScss.margin_left__8m, _ladifireCssSassIndexScss.margin_right__8m, _ladifireCssSassIndexScss.margin_top__8m, _ladifireCssSassIndexScss.margin_bottom__8m, _ladifireCssSassIndexScss.pointer_event__none, {
      [_ladifireCssSassIndexScss.opacity__1]: isHovered
    })
  })), children && /*#__PURE__*/_react.createElement("span", {
    className: classNames(_ladifireCssSassIndexScss, _ladifireCssSassIndexScss.text_align__start, _ladifireCssSassIndexScss.margin_left__12, {
      [_ladifireCssSassIndexScss.opacity__05]: isDisabled
    })
  }, children));
}
/**
 * Checkboxes allow users to select multiple items from a list of individual items,
 * or to mark one individual item as selected.
 */


export let Checkbox = /*#__PURE__*/_react.forwardRef($ad86caa2b7c07dadd21ed122a0b52380$var$Checkbox);
//# sourceMappingURL=module.js.map
